package com.njcn.common.utils.sm;

import sun.misc.BASE64Decoder;
import sun.misc.BASE64Encoder;

import java.io.IOException;
import java.util.regex.Matcher;
import java.util.regex.Pattern;

/**
 * @author yexibao
 */
public class Sm4Utils {
    //全局秘钥
    public final static String globalSecretKey = "11HDESaAhiHHug2z";

    private String secretKey = "";

    private String iv = "";

    private final boolean HEX_STRING = false;

    public String getSecretKey() {
        return secretKey;
    }

    public void setSecretKey(String secretKey) {
        this.secretKey = secretKey;
    }

    public String getIv() {
        return iv;
    }

    public void setIv(String iv) {
        this.iv = iv;
    }

    public Sm4Utils(String secretKey) {
        this.secretKey = secretKey;
    }

    public String encryptData_ECB(String plainText) {
        try {
            Sm4Context ctx = new Sm4Context();
            ctx.isPadding = true;
            ctx.mode = Sm4.SM4_ENCRYPT;

            byte[] keyBytes;
            if (HEX_STRING) {
                keyBytes = util.hexStringToBytes(secretKey);
            } else {
                keyBytes = secretKey.getBytes();
            }

            Sm4 sm4 = new Sm4();
            sm4.sm4_setkey_enc(ctx, keyBytes);
            byte[] encrypted = sm4.sm4_crypt_ecb(ctx, plainText.getBytes("GBK"));
            String cipherText = new BASE64Encoder().encode(encrypted);
            if (cipherText != null && cipherText.trim().length() > 0) {
                Pattern p = Pattern.compile("\\s*|\t|\r|\n");
                Matcher m = p.matcher(cipherText);
                cipherText = m.replaceAll("");
            }
            return cipherText;
        } catch (Exception e) {
            return null;
        }
    }

    public String decryptData_ECB(String cipherText) {
        try {
            Sm4Context ctx = new Sm4Context();
            ctx.isPadding = true;
            ctx.mode = Sm4.SM4_DECRYPT;

            byte[] keyBytes;
            if (HEX_STRING) {
                keyBytes = util.hexStringToBytes(secretKey);
            } else {
                keyBytes = secretKey.getBytes();
            }

            Sm4 sm4 = new Sm4();
            sm4.sm4_setkey_dec(ctx, keyBytes);
            byte[] decrypted = sm4.sm4_crypt_ecb(ctx, new BASE64Decoder().decodeBuffer(cipherText));
            String tempText = new String(decrypted, "GBK");
            String finalText = "";
            for (int i = 0; i < tempText.length(); i++) {
                char c = tempText.charAt(i);
                if ((int) c != 0) {
                    finalText += c;
                }
            }
            return finalText;
        } catch (Exception e) {
            return null;
        }
    }

    public String encryptData_CBC(String plainText) {
        try {
            Sm4Context ctx = new Sm4Context();
            ctx.isPadding = true;
            ctx.mode = Sm4.SM4_ENCRYPT;

            byte[] keyBytes;
            byte[] ivBytes;
            if (HEX_STRING) {
                keyBytes = util.hexStringToBytes(secretKey);
                ivBytes = util.hexStringToBytes(iv);
            } else {
                keyBytes = secretKey.getBytes();
                ivBytes = iv.getBytes();
            }

            Sm4 sm4 = new Sm4();
            sm4.sm4_setkey_enc(ctx, keyBytes);
            byte[] encrypted = sm4.sm4_crypt_cbc(ctx, ivBytes, plainText.getBytes("GBK"));
            String cipherText = new BASE64Encoder().encode(encrypted);
            if (cipherText != null && cipherText.trim().length() > 0) {
                Pattern p = Pattern.compile("\\s*|\t|\r|\n");
                Matcher m = p.matcher(cipherText);
                cipherText = m.replaceAll("");
            }
            return cipherText;
        } catch (Exception e) {
            return null;
        }
    }

    public String decryptData_CBC(String cipherText) {
        try {
            Sm4Context ctx = new Sm4Context();
            ctx.isPadding = true;
            ctx.mode = Sm4.SM4_DECRYPT;

            byte[] keyBytes;
            byte[] ivBytes;
            if (HEX_STRING) {
                keyBytes = util.hexStringToBytes(secretKey);
                ivBytes = util.hexStringToBytes(iv);
            } else {
                keyBytes = secretKey.getBytes();
                ivBytes = iv.getBytes();
            }

            Sm4 sm4 = new Sm4();
            sm4.sm4_setkey_dec(ctx, keyBytes);
            byte[] decrypted = sm4.sm4_crypt_cbc(ctx, ivBytes, new BASE64Decoder().decodeBuffer(cipherText));
            return new String(decrypted, "GBK");
        } catch (Exception e) {
            return null;
        }
    }

    public static void main(String[] args) throws IOException {
        String plainText = "@#001njcnpqs";
        //11HDESaAhiHHugDz
        String secretKey = "11HDESaAhiHHug2z";
        Sm4Utils sm4 = new Sm4Utils(secretKey);

        String cipherText = sm4.encryptData_ECB(plainText);
        System.out.println("加密后：" + cipherText);
        String cipherText1 = sm4.decryptData_ECB(cipherText);
        System.out.println("解密后：" + cipherText1);

        cipherText = cipherText + "11HDESaAhiHHug2z";
        sm4.setSecretKey("11HDESaAhiHHug2z");
        cipherText = sm4.encryptData_ECB(cipherText);
        plainText = sm4.decryptData_ECB(cipherText);
        sm4.setIv("UISwD9fW6cFh9SNS");
        cipherText = sm4.encryptData_CBC(plainText);

        plainText = sm4.decryptData_CBC(cipherText);
    }
}
